Package org.eclipse.graphiti.ui.internal.services

## Interface IGefService

All Known Implementing Classes:
  `GefService`

    public interface IGefService

### Method Summary

All Methods Instance Methods Abstract Methods
`IDimension` `calculateTextSize​(java.lang.String text, Font font)` Calculates and returns the size of the text ignoring any new line characters in the string.
`IDimension` `calculateTextSize​(java.lang.String text, Font font, boolean handleMultiline)` Calculates and returns the size of the text.
`org.eclipse.draw2d.geometry.Point` `calculateTranslation​(org.eclipse.gef.EditPart source, org.eclipse.gef.EditPart target)` Returns the translation between the coordinate-systems of EditParts.
`org.eclipse.gef.EditPart` `findEditPartAt​(org.eclipse.gef.EditPartViewer viewer, org.eclipse.draw2d.geometry.Point location, boolean includeConnections)`
`org.eclipse.draw2d.geometry.Point` `getAbsolutePointOnConnection​(Connection c, double distance)`
`org.eclipse.draw2d.geometry.Point` `getChopboxLocationOnBox​(org.eclipse.draw2d.geometry.Point reference, org.eclipse.draw2d.geometry.Rectangle box)` This method has to be kept in sync with `ChopboxAnchorFixed.getLocation(Point)`.
`org.eclipse.draw2d.geometry.Point` `getConnectionPointAt​(Connection c, double d)`
`java.util.List<org.eclipse.gef.EditPart>` `getConnectionsContainedInEditPart​(org.eclipse.gef.EditPart ep)` Computes EditParts of the connections and related ConnectionDecorators which live inside the containment hierarchy of the given edit part.
`double` `getDistance​(org.eclipse.draw2d.geometry.Point[] points)`
`org.eclipse.draw2d.geometry.Point` `getDistantPoint​(int startX, int startY, int endX, int endY, double distance)`
`org.eclipse.draw2d.geometry.Point` `getDistantPoint​(org.eclipse.draw2d.geometry.Point start, org.eclipse.draw2d.geometry.Point end, double distance)`
`java.util.List<org.eclipse.gef.EditPart>` `getEditPartChildren​(org.eclipse.gef.EditPart editPart)` Provides the direct children of the edit part.
`java.lang.Object` `getLayoutConstraint​(org.eclipse.gef.EditPart editPart)` Returns the layout constraint for the given EditPart.
`org.eclipse.draw2d.geometry.Point` `getPointAt​(int startX, int startY, int endX, int endY, double d)`
`org.eclipse.draw2d.geometry.Point` `getPointAt​(org.eclipse.draw2d.geometry.Point start, org.eclipse.draw2d.geometry.Point end, double d)`
`java.util.List<org.eclipse.gef.EditPart>` `getSelectedEditParts​(org.eclipse.gef.EditPartViewer editPartViewer)` Provides the selected edit parts of the viewer.
`java.util.List<org.eclipse.gef.GraphicalEditPart>` `getSourceConnections​(org.eclipse.gef.GraphicalEditPart graphicalEditPart)` Provides the source connections of the graphical edit part.
`java.util.List<org.eclipse.gef.GraphicalEditPart>` `getTargetConnections​(org.eclipse.gef.GraphicalEditPart graphicalEditPart)` Provides the target connections of the graphical edit part.
`void` `mirrorArray​(org.eclipse.draw2d.geometry.Point[] draw2dPoints)`
`void` `selectEditPart​(org.eclipse.gef.EditPartViewer viewer, java.lang.Object modelObject)` Selects the EditPart for the given model Object.

### Method Detail

#### selectEditPart

    void selectEditPart​(org.eclipse.gef.EditPartViewer viewer,
                        java.lang.Object modelObject)

Selects the EditPart for the given model Object.

Parameters:
  `viewer` - The viewer, which contains the EditParts.
  `modelObject` - The model Object, which EditPart to select.

#### calculateTranslation

    org.eclipse.draw2d.geometry.Point calculateTranslation​(org.eclipse.gef.EditPart source,
                                                           org.eclipse.gef.EditPart target)

Returns the translation between the coordinate-systems of EditParts. It will translate from the coordinate-system of the source EditPart to the coordinate-system of the target EditPart. Both EditParts must be an instance of GraphicalEditPart. Otherwise it throws an Exception.

Parameters:
  `source` - The EditPart with the source coordinate-system.
  `target` - The EditPart with the target coordinate-system.
Returns:
  Returns the translation between the coordinate-systems of EditParts.

#### getLayoutConstraint

    java.lang.Object getLayoutConstraint​(org.eclipse.gef.EditPart editPart)

Returns the layout constraint for the given EditPart. It returns null, if the constraint can not be determined, for example because the child has no parent or the parent has no LayoutManager.

Parameters:
  `editPart` - The EditPart for which to return the layout constraint.
Returns:
  Returns the layout constraint for the given EditPart.

#### findEditPartAt

    org.eclipse.gef.EditPart findEditPartAt​(org.eclipse.gef.EditPartViewer viewer,
                                            org.eclipse.draw2d.geometry.Point location,
                                            boolean includeConnections)

Parameters:
  `viewer` -
  `location` - : the absolute location for the whole RootEditpart (if any, the scroll should be considered)
  `includeConnections` -
Returns:

#### getConnectionsContainedInEditPart

    java.util.List<org.eclipse.gef.EditPart> getConnectionsContainedInEditPart​(org.eclipse.gef.EditPart ep)

Computes EditParts of the connections and related ConnectionDecorators which live inside the containment hierarchy of the given edit part.

Parameters:
  `ep` - the EditPart whose inner connection and ConnectionDecorators should be computed

#### getConnectionPointAt

    org.eclipse.draw2d.geometry.Point getConnectionPointAt​(Connection c,
                                                           double d)

Parameters:
  `c` -
  `d` -
Returns:

#### getChopboxLocationOnBox

    org.eclipse.draw2d.geometry.Point getChopboxLocationOnBox​(org.eclipse.draw2d.geometry.Point reference,
                                                              org.eclipse.draw2d.geometry.Rectangle box)

This method has to be kept in sync with `ChopboxAnchorFixed.getLocation(Point)`.

#### getAbsolutePointOnConnection

    org.eclipse.draw2d.geometry.Point getAbsolutePointOnConnection​(Connection c,
                                                                   double distance)

Parameters:
  `c` -
  `absDistance` - absDistance > 0 means distance from beginning. absDistance < 0 means distance from connection end.
Returns:

#### getDistantPoint

    org.eclipse.draw2d.geometry.Point getDistantPoint​(org.eclipse.draw2d.geometry.Point start,
                                                      org.eclipse.draw2d.geometry.Point end,
                                                      double distance)

#### getDistantPoint

    org.eclipse.draw2d.geometry.Point getDistantPoint​(int startX,
                                                      int startY,
                                                      int endX,
                                                      int endY,
                                                      double distance)

#### getPointAt

    org.eclipse.draw2d.geometry.Point getPointAt​(int startX,
                                                 int startY,
                                                 int endX,
                                                 int endY,
                                                 double d)

Parameters:
  `startX` -
  `startY` -
  `endX` -
  `endY` -
  `d` -
Returns:

#### getPointAt

    org.eclipse.draw2d.geometry.Point getPointAt​(org.eclipse.draw2d.geometry.Point start,
                                                 org.eclipse.draw2d.geometry.Point end,
                                                 double d)

#### getDistance

    double getDistance​(org.eclipse.draw2d.geometry.Point[] points)

#### calculateTextSize

    IDimension calculateTextSize​(java.lang.String text,
                                 Font font)

Calculates and returns the size of the text ignoring any new line characters in the string.

Parameters:
  `text` -
  `font` -
Returns:
  the size of the text
See Also:
  `calculateTextSize(String, Font, boolean)`

#### calculateTextSize

    IDimension calculateTextSize​(java.lang.String text,
                                 Font font,
                                 boolean handleMultiline)

Calculates and returns the size of the text.

Parameters:
  `text` -
  `font` -
  `handleMultiline` - Defines if line breaks in the string should be used in the calculation of the size or not. In case `true`, a new line character in the string will increase the size of the returned dimensions by one line, in case `false` a new line character will be ignored.
Returns:
  the size of the text

#### mirrorArray

    void mirrorArray​(org.eclipse.draw2d.geometry.Point[] draw2dPoints)

Parameters:
  `draw2dPoints` -

#### getEditPartChildren

    java.util.List<org.eclipse.gef.EditPart> getEditPartChildren​(org.eclipse.gef.EditPart editPart)

Provides the direct children of the edit part.

Parameters:
  `editPart` -
Returns:
  the direct child edit parts

#### getSourceConnections

    java.util.List<org.eclipse.gef.GraphicalEditPart> getSourceConnections​(org.eclipse.gef.GraphicalEditPart graphicalEditPart)

Provides the source connections of the graphical edit part.

Parameters:
  `graphicalEditPart` -
Returns:
  the source connections of the graphical edit part

#### getTargetConnections

    java.util.List<org.eclipse.gef.GraphicalEditPart> getTargetConnections​(org.eclipse.gef.GraphicalEditPart graphicalEditPart)

Provides the target connections of the graphical edit part.

Parameters:
  `graphicalEditPart` -
Returns:
  the target connections of the graphical edit part

#### getSelectedEditParts

    java.util.List<org.eclipse.gef.EditPart> getSelectedEditParts​(org.eclipse.gef.EditPartViewer editPartViewer)

Provides the selected edit parts of the viewer.

Parameters:
  `editPartViewer` -
Returns:
  the selected edit parts of the viewer